/**
 * AMS mobile pairing
 **/

// These can be set by the page BEFORE loading this script file.
// If they are not loaded BEFORE loading this file, default values are used.
// They can also be assigned values when calling amsPairingLoad from a handler.
try {if (testForPairingInst==undefined) {var testForPairingInst = false;}}
catch (e) {var testForPairingInst = false;}
try {if (doPairing==undefined) {var doPairing = false;}} 
catch (e) {var doPairing = false;}
try {if (addPairingListener==undefined) {var addPairingListener = false;}}
catch (e) {var addPairingListener = false;}
try {if (forcePairing==undefined) {var forcePairing = false;}}
catch (e) {var forcePairing = false;}
try {if (showCurrentPairingInfo==undefined) {var showCurrentPairingInfo = false;}}
catch (e) {var showCurrentPairingInfo = false;}

if (addPairingListener) {
    $(document).ready(function() { amsPairingLoad(); })
}

var ajaxUrl = "/PairKeySetup";
if (!top.location.host.match(/^(thor)|(qa)|(preview)|(ngb)|(localhost)/))
   // need hardcoded host because this might come from mirror site
   ajaxUrl = "http://www.ams.org"+ajaxUrl;

var amsPairingCookieName = "amspairing";
var wannaRenewCookieName = "amspairingRenewOffer";
var localStorageName = "Syw5vAzdEoHkB72FYXm7oVNx";
var amsPairingNextPage = null;
var amsPairingDivToShow = null;
var amsPairingDivToHide = null;
var whereWeCameFrom = document.referrer;
var pairedInstitution = null;

function amsPairingLoad(p) {
   if (p == null || p == undefined) p = {};
   amsPairingDivToShow = p.successShowDiv;
   amsPairingDivToHide = p.successHideDiv;
    amsPairingNextPage = p.nextPage;
    
   if (supportsLocalStorage()) {
       var dataToAjax = new Object();
       if (getPairKey() == null) {
           amsPairingDebug("local storage pairKey was null");
       } else {
           if (getPairCookie() == null) {
               amsPairingDebug("local storage pairKey with name "+
                               localStorageName+" has value: "+getPairKey()+
                               "<br />&nbsp;&nbsp;&nbsp;but cookie was null");
               if (doPairing) createPairCookie();
           } else {
               amsPairingDebug("local storage pairKey is "+getPairKey()+
                               " and cookie is: "+getPairCookie());
               if (getPairKey() != getPairCookie()) {
                   amsPairingDebug("Resetting local storage to match "+
                                   "cookie.");
                   setPairKey(getPairCookie());
                   deleteCookie(wannaRenewCookieName);
               }
           }
           dataToAjax[localStorageName] = getPairKey();
           amsPairingDebug("doPairing: "+doPairing);
       }
       if (doPairing) dataToAjax.p = 1; 
       if (testForPairingInst) dataToAjax.t = 1; 
       if (forcePairing) dataToAjax.f = 1; 
       amsPairingDebug("Ready to call: "+ajaxUrl+
                       "\n  with data: "+JSON.stringify(dataToAjax));
       $.ajax({
           url: ajaxUrl,
           dataType: 'json',
           data: dataToAjax,
           success: pairingAjaxCatcher, // jQuery < 1.8
           //done: pairingAjaxCatcher, // jQuery 1.8+
           complete: ngbTestAjaxDone, // jQuery < 1.8
           //always:  ngbTestAjaxDone, // jQuery 1.8+
           error: ngbTestError // jQuery < 1.8
           //fail: ngbTestError // jQuery 1.8+
       });
   } else {
       showDifferentDiv("cannotPairDevice");
       showCustomerNameInfo();
   }
}

function pairingAjaxCatcher(pairingData, textStatus, jqXHR) {
    // pairingData may be null in some very old browsers
    if (pairingData == null) return;
    if (pairingData.newKey) {
        storePairKey(pairingData);
    } else {
        processJsonData(pairingData);
    }
}

function storePairKey(pairingData) {
    if (pairingData) {
        amsPairingDebug("Setting pair key: "+pairingData.device);
        setPairKey(pairingData.device);
        if (doPairing) {
            createPairCookie();
            deleteCookie(wannaRenewCookieName);
        }
        processJsonData(pairingData);
    } else {
        amsPairingDebug("Got no data. Not setting pair key.");
    }
}

function processJsonData(pairingData) {
    var customer = null;
    var cusnum = null;
    var cuscode = null;
    var newDevice = null;
    if (false)
    $("#pairingtest").html(function(i, o)
                           {return o+"Starting processJsonData "+new Date()+
                            "<br />\n<pre>"+JSON.stringify(pairingData)+
                            "\n</pre>\n";});
    if (pairingData != null) {
        customer = pairingData.customer;
        if (customer != null) cuscode = customer.cuscode;
        newDevice = pairingData.device;
        amsPairingDebug("Pairing key from ajax is: "+pairingData.device);
        if (cuscode != null) amsPairingDebug("cuscode from ajax is: "+cuscode);
        try {  // need this to be in a try/catch because IE is so stupid.
            amsPairingDebug("pairingData is:\n"+JSON.stringify(pairingData)+
                            "<br />\n");
        } catch (e) {
            // do nothing if using a brain-dead browser
        }
    } else {
        amsPairingDebug("pairingData is null");
    }

    if ( newDevice != null && newDevice != getPairKey() ) {
        amsPairingDebug("Replacing old pairKey "+getPairKey()+
                   " with new pairKey: "+newDevice);
        setPairKey(newDevice);
        if (doPairing) {
            createPairCookie();
            deleteCookie(wannaRenewCookieName);
        }
    } else {
        amsPairingDebug(getPairKey()+" = "+newDevice);
    }

    amsPairingDebug("Referer page was: "+whereWeCameFrom);

    var theirname = "undefined";
    if (cuscode != null) {
        theirname = customer.inst_name;
        if (testForPairingInst && !doPairing) {
            // If we know who they are but are not pairing, it means
            // that it's time to show the license agreement,
            // unless they are not currently on a customer's network
            if (pairingData.cannot_switch || showCurrentPairingInfo) {
                return(compareExistingCustomerWithCurrentCustomer(pairingData));
            }
            if (amsPairingDivToShow != null ) {
                return(showDifferentDiv(amsPairingDivToShow, pairingData));
            } else if (amsPairingNextPage) {
                window.location = amsPairingNextPage;
            }
        }
    } else if (testForPairingInst || doPairing) {
        // If cuscode is null, it might mean that the current IP
        // is associated with a different customer than the
        // current pairing record for this device.
        compareExistingCustomerWithCurrentCustomer(pairingData);
    }
    if (false)
    $("#pairingtest").html("You are associated with: "+theirname+
                           " via pairing key: "+getPairKey());
    showCustomerNameInfo(pairingData);
    if (doPairing) {
        if (amsPairingDivToShow != null ) {
            return(showDifferentDiv(amsPairingDivToShow, pairingData));
        } else if (amsPairingNextPage) {
            window.location = amsPairingNextPage;
        }
    }
}

function compareExistingCustomerWithCurrentCustomer(pairingData) {
    var alreadyPaired = pairingData.already_paired;
    var currentCustomers = pairingData.current_customers;
    if (alreadyPaired == null) alreadyPaired = new Object();
    if (currentCustomers == null) currentCustomers = new Object();

    // We assign this to a global variable so that we can
    // display it if they choose not to change their pairing
    pairedInstitution = alreadyPaired.inst_name;
    var days_left = "";
    for (thisCuscode in alreadyPaired) {
        if (!thisCuscode.match(/_/) && 
            alreadyPaired[thisCuscode].pairing_days_left != undefined &&
            alreadyPaired[thisCuscode].pairing_days_left.match(/\d/)
           ) {
            days_left = alreadyPaired[thisCuscode].pairing_days_left;
            if (pairedInstitution == null || pairedInstitution == "") {
                pairedInstitution = (alreadyPaired[thisCuscode].inst_name) ?
                  alreadyPaired[thisCuscode].inst_name :
                  alreadyPaired[thisCuscode].cusname;
            }
            break;
        }
    }
    if (pairedInstitution != null && pairedInstitution != "") {
        $('span[name="amsInstitutionName"]').html(pairedInstitution);
        $('span[name="amsPairingDaysLeft"]').html(days_left);
    } else {
        $('span[name="amsInstitutionName"]').html("no current paired institution");
        $('span[name="amsPairingDaysLeft"]').html("0");
    }
    $('span[name="amsPairingDeviceKey"]').html(getPairKey());
    $('span[name="amsPairingDaysLeft"]').show();
    if (showCurrentPairingInfo && 
        pairedInstitution != null && pairedInstitution != "") {
        $('#currentAmsPairingInfo').show();
    } else {
        $('#currentAmsPairingInfo').hide();
    }
    if (pairingData.cannot_switch != null) $('#cannotSwitchDiv').show();
    if (currentCustomers.inst_name != null) {
        $('span[name="newInstitutionName"]').html(currentCustomers.inst_name);
        showDifferentDiv('askToSwitchCustomer');
    } else {
        showDifferentDiv('noCurrentCustomer');
    }
}

function showDifferentDiv(divToShow, pairingData) {
    if (divToShow == null) divToShow = amsPairingDivToShow;
    if (divToShow == null) {
        amsPairingDebug("Cannot show different div; no div to show");
        return;
    }
    $('div[name="amsPairingDiv"]').slideUp();
    $('#'+divToShow).show('slow');
    showCustomerNameInfo(pairingData);
}

function showCustomerNameInfo(pairingData, textStatus, jqXHR) {
    amsPairingDebug("Referer is: "+whereWeCameFrom);
    if ( whereWeCameFrom != null && !whereWeCameFrom.match(/^\s*$/)) {
        $('div[name="linkBackToReferer"]').show();
        $('a[name="returnHereWhenDone"]').html(whereWeCameFrom);
        $('a[name="returnHereWhenDone"]').attr('href', whereWeCameFrom);
    }
    if (pairingData == null) {
        amsPairingDebug("CANNOT SHOW CUSTOMER INFO pairingData is null");
        return;
    }
    if (pairingData.customer == null) {
        amsPairingDebug("CANNOT SHOW CUSTOMER INFO customer is null");
        return;
    }
    $('span[name="amsInstitutionName"]').html(pairingData.customer.inst_name);
    $('span[name="amsCustomerCode"]').html(pairingData.customer.cuscode);
    if (pairingData != null && pairingData.current_customers != null) {
        $('span[name="pairingInstitutionName"]').html(pairingData.current_customers.inst_name);
    } else {
        $('span[name="pairingInstitutionName"]').html(pairedInstitution);
    }
}

function notPairingNow() {
    // There's no customer info to show, but this will show the
    // link to the referer
    showCustomerNameInfo();
    if (pairedInstitution != null && pairedInstitution != undefined) {
        showDifferentDiv('keepExistingPairing');
    } else {
        showDifferentDiv('notPairing');
    }
}

function amsPairingDebug(s) {
    if (false) 
    $("#debug").html(function(index, oldhtml) {return oldhtml+s+"<br />\n"});
}

function ngbTestError(pairingData, textStatus, jqXHR) {
    if (pairingData.error) 
        $("#errors").html(pairingData.error);
}

function ngbTestAjaxDone(pairingData, textStatus, jqXHR) {
    var s = "Done with ajax call with status: ";
    if ( pairingData.status ) {
        s += pairingData.status;
    } else if (pairingData.error) {
        s += "ERROR: "+pairingData.error;
    } else {
        s += "unknown";
    }
    if (false)
    $("#pairingtest").html(function(i, o){return o+"<br />\n"+s+"<br />\n";});
}

function supportsLocalStorage() {
    try {
        return 'localStorage' in window && window['localStorage'] !== null;
    } catch(e){
        return false;
    }
}

function getPairKey() {
    return localStorage.getItem(localStorageName);
}

function setPairKey(pairkey) {
    localStorage.setItem(localStorageName, pairkey);
    amsPairingDebug("Setting new pair key in local storage to: "+pairkey);
}

function deletePairKey(debug) {
    if (supportsLocalStorage()) {
        var goAhead = false;
        amsPairingDebug("local storage pairKey with name "+localStorageName+
                        " has value: "+getPairKey());
        if (debug) {
            goAhead = confirm("Go ahead and remove pair key? "+getPairKey());
        }
        if (goAhead) {
           localStorage.removeItem(localStorageName);
           if (debug) alert("Pair key is now: "+getPairKey());
        } else {
            if (debug) alert("Did not change pairkey: "+getPairKey());
        }
    } else if (debug) {
        alert("Local storage not supported");
    }
}

function createPairCookie() {
    var key = getPairKey();
    amsPairingDebug("Creating new pair cookie with value "+key);
    if (key != null) {
        var myDomain = ".ams.org";
        if (top.location.host.match(/^localhost/)) myDomain = null;
        // need to add path, host, expiration
        var now = new Date();
        var expYear = now.getFullYear()+1;
        var expDate = new Date(expYear, now.getMonth(), now.getDate());
        setCookie(amsPairingCookieName, key, expDate, "/", myDomain);
    }
}

function getPairCookie() {
    return getCookie(amsPairingCookieName);
}

function deletePairCookie() {
    deleteCookie(amsPairingCookieName);
}

function deletePairing() {
    deletePairCookie();
    deletePairKey();
}

/** 
 * Cookie utilities used by MathSciNet, useful for pairing
 **/

/*
   name - name of the cookie
   value - value of the cookie
   [expires] - expiration date of the cookie
   (defaults to end of current session)
   [path] - path for which the cookie is valid
   (defaults to path of calling document)
   [domain] - domain for which the cookie is valid
   (defaults to domain of calling document)
   [secure] - Boolean value indicating if the cookie transmission requires
   a secure transmission
 * an argument defaults when it is assigned null as a placeholder
 * a null placeholder is not required for trailing omitted arguments
 */

function setCookie(name, value, expires, path, domain, secure) {
    var curCookie = name + "=" + escape(value) +
	((expires) ? "; expires=" + expires.toGMTString() : "") +
	((path) ? "; path=" + path : "") +
	((domain) ? "; domain=" + domain : "") +
	((secure) ? "; secure" : "");
    document.cookie = curCookie;
}


/*
   name - name of the desired cookie
   return string containing value of specified cookie or null
   if cookie does not exist
 */

function getCookie(name) {
    var dc = document.cookie;
    var prefix = name + "=";
    var begin = dc.indexOf("; " + prefix);
    if (begin == -1) {
	begin = dc.indexOf(prefix);
	if (begin != 0) return null;
    } else
	begin += 2;
    var end = document.cookie.indexOf(";", begin);
    if (end == -1)
	end = dc.length;
    return unescape(dc.substring(begin + prefix.length, end));
}


/*
   name - name of the cookie
   [path] - path of the cookie (must be same as path used to create cookie)
   [domain] - domain of the cookie (must be same as domain used to
   create cookie)
   path and domain default if assigned null or omitted if no explicit
   argument proceeds
 */

function deleteCookie(name, path, domain) {
    if (getCookie(name)) {
	document.cookie = name + "=" +
	    ((path) ? "; path=" + path : "") +
	    ((domain) ? "; domain=" + domain : "") +
	    "; expires=Thu, 01-Jan-70 00:00:01 GMT";
    }
}

// date - any instance of the Date object
// * hand all instances of the Date object to this function for "repairs"

function fixDate(date) {
    var base = new Date(0);
    var skew = base.getTime();
    if (skew > 0)
	date.setTime(date.getTime() - skew);
}
